%ext ck5
%version 1.4
# Load the modified graphics
%egahead EGAHEAD.CK5
%patchfile $25B22 keen5.tli 
%maphead maphead.ck5
%gamemaps editmaps.ck5

###########
# general #
###########
#Keen starts in first level
#%patch $698F $6F68W $0001W

#Stop the stun stars appearing
%patch $AA70  $5F $5E $8B $E5 $5D $CB

#Shelly fragments look like stun stars (Guts)
%patch $328FA $008FW $008FW #Left
%patch $32918 $0090W $0090W #Right

#Mine fragments look like stun stars (Guts)
%patch $32A56 $0091W $0091W

########
# Keen #
########
%patch $DC9D $EB $12 #Keen can always shoot, don't lose ammo



#############
# Shot position
#############
#Right Keen - Right 256,64
%patch $BDCF $FFA8W #Vertical position
%patch $BDD6 $0100W #Horizontal position
#Left Keen - Left -128,64
%patch $BDEB $FFA8W #Vertical position
%patch $BDF2 $0080W #Horizontal position

#Right Keen - Right 32,256 Jumping
%patch $BE12 $FFD0W #Vertical position
%patch $BE19 $0100W #Horizontal position
#Left Keen - Left 32,0 Jumping
%patch $BE2E $FFD0W #Vertical position


%patch $BE92 $009AW #UP Horizontal position

##############
# Actions
##############
#Shot
%patch $3187C $1502W #Keen's shot 2 to 1

#%patch $318D6 $153EW #smash 1 -> bullet 3
#%patch $318B8 $1598W #bullet 4 -> smash 2

#sprite tile
#%patch $31896 $090B17B5RL #Keen's shot 3
#%patch $318B4 $090B17B5RL #Keen's shot 4

##############
#Keen Animations
##############
#looking down
%patch $30E3E $008AW $0089W #Look down
%patch $30E5C $008AW $0089W #Look down-duck
%patch $30E7A $008AW $0089W #Look down-duck
%patch $30E98 $008AW $0089W #Look down
%patch $30EB6 $008AW $0089W #Look down

#Shooting
%patch $30F4C $0072W $0073W #Shoot l/r 2
%patch $30F88 $00A2W $00A2W #Shoot up 2

%patch $313FC $0095W $0094W #Shoot l/r in air

%patch $31442 $0001W        #Pause before keep falling

#Sit on pole
%patch $3110E $009FW $009FW #Sit on pole

#Go up pole
%patch $3112C $009FW $009FW #Go up pole
%patch $3114A $00A0W $00A0W #Go up pole
%patch $31168 $00A1W $00A1W #Go up pole

#Go down pole
%patch $31186 $00A0W $00A0W #Go down pole
%patch $311A4 $009FW $009FW #Go down pole
%patch $311C2 $00A1W $00A1W #Go down pole
%patch $311E0 $009FW $009FW #Go down pole



#Continuous firing when shooting while...
%patch $AE70 $EB $04 #Standing still
%patch $B27C $EB $04 #Walking
%patch $B882 $EB $04 #Jumping
%patch $B9FE $EB $04 #Pogoing
%patch $BA6D $EB $04 #On poles


#Jump/fall
%patch $31384 $0079W $0071W #Jumping
%patch $313A2 $0079W $0071W #Jump/fall
%patch $313C0 $0079W $0071W #fall
%patch $313DE $0079W $0071W #fall

#%patch $313A0 $1044W #Keen action jumping

#Shooting l/r 4 shots
#%patch $30F32 $0003W #Doesn't fall
#%patch $30F50 $0003W #Doesn't fall

#################
# Enemy Shooter #
#################

##########
# Ampton #
##########

#Ampton takes 3 hits to kill (By Lemm)
%patch $11635 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
              $9A $0AAF1517RL     $5F $5E $5D $CB
                                                  $83 $3D $03 $75 $F7 $FF $4C #New Stuff STarts here
              $40 $83 $7C $40 $FA $7F $1B $B8 $16 $00 $50 $9A $196E09EFRL     #Hits = 6 ($FA)
              $44 $44 $B8 $9E $23 $50 $57 $56 $9A $090B16CDRL     $83 $C4 $06 #Change sound to 16
              $EB $D3 $C7 $44 $42 $01 $00 $57 $9A $0CCB10B3RL     $44 $44 $EB
              $EF
%patch $1170D $EA $11C415CDRL 
##############
# Volte Face #
##############
#Volte-face sprite type
%patch $10AF0 $06

#Moving behaviour
%patch $3201C $00000000L  #Nothing
%patch $3203A $00000000L  #Nothing
%patch $32058 $00000000L  #Nothing
%patch $32076 $00000000L  #Nothing

###################
# Purple Platform #
###################


#################
# Purple Goplat #
#################
#stops and shoot in direction
#%patch $31F8E $01A6W $01A6W    $0003W       $0000W     $0000W    $00B0W       $0000W   $0000W
#              $0F921005RL  $00000000L  $11020897RL       $1C6CW
#%patch $31FAC $01A7W $01A7W    $0000W       $0000W     $0000W    $0020W       $0000W   $0000W
#                $0F9215FDRL  $090B19C6RL   $11020897RL       $1C4EW

#stand still and shoot in direction
%patch $31F8E $01A6W $01A6W    $0003W       $0000W     $0000W    $00B0W       $0040W   $0000W
               $00000000L  $00000000L  $11020897RL       $1C6CW
%patch $31FAC $01A7W $01A7W    $0000W       $0000W     $0000W    $0010W       $0040W   $0000W
               $0F9215FDRL  $090B19C6RL   $11020897RL       $1C4EW


#############
# Spindread #
#############
#behaviour
#$11C40CA6RL 11c40 + ca6
#%patch $128e6 $55 $8B $EC $56 $8B $76 $06 $9A $1DFB0036RL     $3D $0040W  $7D
#              $0B $C7 $44 $1C $2AD6W  $C7 $06 $85 $BF $0000W  $5E $5D $CB


##############
# Spirogrip #
##############

#Custom collision: Kill Keen and block shots sprite collision
%patch $AA76 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
             $9A $0AAF1517RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
             $16 $0000W  $C7 $44 $06 $0001W  $B8 $21BEW  $50 $57 $56 $9A $090B16CDRL
                         $83 $C4 $06 $5F $5E $5D $CB

#Spawn Spirogrip
%patch $127DC $2914W

# new $11C40BAARL Spirogrip behaviour 11c40 + baa = 127EA randomly falls down
%patch $127EA $55 $8B $EC $56 $8B $76 $06 $9A $1DFB0036RL     $3D $0002W  $7D
             $05 $C7 $44 $1C $298CW  $5E $5D $CB





# new spiro sprite-tile interaction $11C40C03RL 11c40+c03=12843
%patch $12843 $55 $8B $EC $56 $8B $76 $06 $83 $7C $36 $00 $75 $12 $83 $7C $38
              $00 $75 $0C $83 $7C $3A $00 $75 $06 $83 $7C $3C $00 $74 $19 $B8
              $001BW  $50 $9A $196E09EFRL     $83 $C4 $02 $B8 $29C8W  $50 $56 #become rotate 7
              $9A $090B1242RL     $83 $C4 $04 $FF $74 $20 $33 $C0 $50 $FF $74
              $1E $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A $174E163ERL
                      $83 $C4 $0C $5E $5D $CB

#oben 1-4 spin
%patch $32C54  $0189W $0189W    $0003W       $0000W     $0000W    $0008W       $0040W   $0000W
               $00000000L  $00000000L  $11020897RL       $2932W

%patch $32C72 $0189W $0189W $0003W       $0000W     $0000W        $0008W       $0040W   $0000W
               $00000000L  $00000000L  $11020897RL       $2950W

%patch $32C90 $0189W $0189W $0003W       $0000W     $0000W        $0008W       $0040W   $0000W
               $00000000L  $00000000L  $11020897RL       $296EW

%patch $32CAE $0189W $0189W $0003W       $0000W     $0000W        $0008W       $0040W   $0000W
               $11C40BAARL  $00000000L  $11020897RL       $2914W

#flug unten spin 5
%patch $32CCC $018FW $018FW $0002W       $0000W     $0000W        $0005W       $0000W   $0000W
               $090B1710RL  $00000000L  $0F920119RL       $29AAW
#flug unten spin 6
%patch $32CEA $0191W $0191W $0002W       $0000W     $0000W        $0008W       $0000W   $0000W
               $090B1710RL  $00000000L  $11C40C03RL       $29AAW

#laufen unten spin 7&8 move down move left

%patch $32D08 $0190W $0190W $0003W       $0000W     $0000W    $0008W       $0040W   $0000W
               $00000000L  $090B19C6RL   $11020897RL       $29E6W

%patch $32D26 $0192W $0192W $0003W       $0000W     $0000W    $0008W       $0040W   $0000W
               $00000000L  $090B19C6RL   $11020897RL       $2A04W

%patch $32D44 $0189W $0189W $0003W       $0000W     $0000W    $0008W       $0040W   $0000W
               $00000000L  $090B19C6RL   $11020897RL       $2A22W

%patch $32D62 $018AW $018AW $0003W       $0000W     $0000W    $0008W       $0040W   $0000W
               $00000000L  $090B19C6RL   $11020897RL       $29C8W


#When hit pogo on it

##########
# Sparky #
##########
#Prepare to charge cycle (skip that)
%patch $323D0 $210AW #Sparky prepare to charge



#Stunned
%patch $32508 $000AW   #Animation speed
%patch $3250E  $11C40783RL #behaviour Shikadi Mine explode
%patch $32502 $0000W #action type


##############
# Shockshund #
##############

#Behaviour
#Stunned
%patch $3336C $11C40783RL #behaviour Shikadi Mine explode

#Shocksund strength
%patch $1328A $0005W

#Bark frequency
%patch $1330E $9D

#Animations
#Shocksund bark
%patch $3321C $0018W        #Animation speed
%patch $3323A $0008W        #Animation speed
%patch $33366 $000AW        #Animation speed stunned

#Spawn hight
#Shot Spawn height
%patch $13357 $FFD0W #Vertical


#%patch $126CE $0000W #2 tiles down from sprite top
#%patch $3321C $0020W

%patch $33360 $0000W #action type stunned
##########
# Korath #
##########

%patch $334B8 $11C40783RL #behaviour Shikadi Mine explode
%patch $334AC $0000W # action type
%patch $334B2 $0009W #Animation speed

################
# Shikadi Mine #
################
#Shikadi Mine fragments
%patch $32A6A $00000000L #Shikadi mine fragments 

#Spawn fragment when detonating

%patch $1240C $2716W #Shelly fragment right

%patch $1244F $25D8W #Shikadi Mine fragments (When Mine explodes)

%patch $12490 $25BAW #Shelly fragment left

%patch $124D6 $2716W #Shikadi Mine fragments (When Mine explodes)

%patch $12509 $25BAW #Shelly fragment left

%patch $1253F $25D8W #Shikadi Mine fragments (When Mine explodes)

###########
# Shelley #
###########

#When spawned
%patch $11998 $24E8W #Shelly fall

#Shelly jump
%patch $11B95 $24ACW #Shelly prepare to jump


%patch $11AF5 $1B     #Shelley explode when shot sound
%patch $11BE0 $1B     #Shelley explode when hitting the ground sound

#Animations Shelly jump
%patch $327CE $01B0W $01ACW #Shelly prepare to jump


#Custom collision: Kill Keen And Become Another Sprite When Shot
#%patch $79F6 $EB $5C # disable boss cheat
#%patch $79F8 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
#             $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
#             $16 $0000W  $C7 $44 $06 $0001W  $B8 $2542W  $50 $57 $56 $9A $09DC1695RL
#                        $83 $C4 $06 $5F $5E $5D $CB


#Custom collision: Kill Keen and block shots sprite collision
%patch $79F6 $EB $5C # disable boss cheat
%patch $79F8 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09
             $9A $0AAF1517RL     $5F $5E $5D $CB $83 $3D $03 $75 $18 $C7 $44
             $16 $0000W  $C7 $44 $06 $0001W  $B8 $2560W  $50 $57 $56 $9A $090B16CDRL #when shot -> smoke 2
                         $83 $C4 $06 $5F $5E $5D $CB

#Behaviour smoke 2 = explode
%patch $328B0 $11C40783RL  #Nothing
#smoke 2 -> vanish
%patch $328BC $0000W
%patch $328AA $0005W       #Animation speed

 

#Walk
%patch $3276A $06B90E68RL
%patch $32788 $06B90E68RL
%patch $327A6 $06B90E68RL
%patch $327C4 $06B90E68RL

#Jump
%patch $327E2 $06B90E68RL
%patch $32800 $06B90E68RL
%patch $3281E $06B90E68RL
%patch $3283C $06B90E68RL


#Shelley push Keen, don't explode
%patch $11AB6 $5F $5E $5D $CB

#Produce these when smashed
%patch $11B3F $0000W #Shelly smash smoke
%patch $11A5A $0000W #Spawn Shelley right fragment
%patch $11A8D $0000W #Spawn Shelley left fragment
#%patch $11B07 $2416W #Shelly smash B (If hit on the ground)
#%patch $11B16 $2416W #Shelly fall A (If hit in air)

#smoke 1 ->vanish, no animation
%patch $3289E $0000W
%patch $32882 $0000W $0000W

#Shelley Smash A
%patch $32862 $2416W
#Shelley Smash B
%patch $32880 $2416W

#Smash smoke
%patch $32896 $00000000L #Deadly
%patch $328B4 $00000000L #Deadly
%patch $328D2 $00000000L #Deadly
%patch $328F0 $00000000L #Deadly

#Fragments
%patch $3290E $00000000L #Deadly
%patch $3292C $00000000L #Deadly

%patch $32766 $11020986RL #Shelly prepare to jump
%patch $32784 $11020986RL #Shelly prepare to jump
%patch $327A2 $11020986RL #Shelly prepare to jump
%patch $327C0 $11020986RL #Shelly prepare to jump

#Shelley don't jump off platform edges
%patch $119B7 $90 $90

#Shelley jump right
%patch $119DA $0020W #Width
%patch $119DF $FFC0W #Height

#Shelley jump left
%patch $11A03 $FFDFW #Width
%patch $11A08 $FFC0W #Height

%level.name 0 Cydonia
%level.entry 0 Colossus explores\n Cydonia 

%level.name 1 Border Town
%level.entry 1 Colossus bursts into\n the Border Town

%end